/*##########################################################################
 #                                                                         #
 #   Simple script shamelessly recopied from:                              #
 #                                                                         #
 #   Copyright                                                             #
 #                                                                         #
 #   (C)  2015 Gennady Knyazkin <gennadyx5@gmail.com>                      #
 #   (C)  2009 Àlvar Cuevas i Fajardo <alvar@cuevas.cat>                   #
 #   (C)  2008 Eirik Johansen Bjørgan  <eirikjbj@gmail.com>                #
 #   (C)  2007, 2008 Nikolaj Hald Nielsen  <nhnFreespirit@gmail.com>       #
 #   (C)  2008 Peter ZHOU <peterzhoulei@gmail.com>                         #
 #   (C)  2008 Mark Kretschmann <kretschmann@kde.org>                      #
 #                                                                         #
 #   This program is free software; you can redistribute it and/or modify  #
 #   it under the terms of the GNU General Public License as published by  #
 #   the Free Software Foundation; either version 2 of the License, or     #
 #   (at your option) any later version.                                   #
 #                                                                         #
 #   This program is distributed in the hope that it will be useful,       #
 #   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
 #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
 #   GNU General Public License for more details.                          #
 #                                                                         #
 #   You should have received a copy of the GNU General Public License     #
 #   along with this program; if not, write to the                         #
 #   Free Software Foundation, Inc.,                                       #
 #   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         #
 ##########################################################################*/

Importer.loadQtBinding('qt.core');
Importer.loadQtBinding('qt.gui');

stations = {
    'rr': {
        'name': 'Radio Record',
        'img': 'images/s-0.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8100/rr_aac.m3u',
            '128': 'http://air.radiorecord.ru:8101/rr_128.m3u',
            '320': 'http://air.radiorecord.ru:8101/rr_320.m3u'
        }
    },
    'tm': {
        'name': 'Trancemission',
        'img': 'images/s-1.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/tm_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/tm_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/tm_320.m3u'
        }
    },
    'ps': {
        'name': 'Pirate Station',
        'img': 'images/s-2.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/ps_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/ps_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/ps_320.m3u'
        }
    },
    'vip': {
        'name': 'Vip Mix',
        'img': 'images/s-3.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/vip_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/vip_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/vip_320.m3u'
        }
    },
    'teo': {
        'name': 'Record Hardstyle',
        'img': 'images/s-4.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/teo_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/teo_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/teo_320.m3u'
        }
    },
    'dc': {
        'name': 'Record Dancecore',
        'img': 'images/s-5.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/dc_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/dc_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/dc_320.m3u'
        }
    },
    'brks': {
        'name': 'Record Breaks',
        'img': 'images/s-6.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/brks_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/brks_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/brks_320.m3u'
        }
    },
    'chil': {
        'name': 'Record Chill-Out',
        'img': 'images/s-7.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/chil_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/chil_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/chil_320.m3u'
        }
    },
    'dub': {
        'name': 'Record Dubstep',
        'img': 'images/s-8.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/dub_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/dub_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/dub_320.m3u'
        }
    },
    'sd90': {
        'name': 'Супердискотека 90-х',
        'img': 'images/s-9.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/sd90_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/sd90_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/sd90_320.m3u'
        }
    },
    'club': {
        'name': 'Record Club',
        'img': 'images/s-10.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/club_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/club_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/club_320.m3u'
        }
    },
    'mdl': {
        'name': 'Медляк FM',
        'img': 'images/s-11.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/mdl_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/mdl_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/mdl_320.m3u'
        }
    },
    'gop': {
        'name': 'Гоп FM',
        'img': 'images/s-12.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/gop_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/gop_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/gop_320.m3u'
        }
    },
    'pump': {
        'name': "Pump'n'Klubb",
        'img': 'images/s-13.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/pump_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/pump_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/pump_320.m3u'
        }
    },
    'rus': {
        'name': 'Russian Mix',
        'img': 'images/s-14.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/rus_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/rus_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/rus_320.m3u'
        }
    },
    'yo': {
        'name': 'Yo Fm',
        'img': 'images/s-15.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/yo_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/yo_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/yo_320.m3u'
        }
    },
    'deep': {
        'name': 'Record Deep',
        'img': 'images/s-16.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/deep_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/deep_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/deep_320.m3u'
        }
    },
    'trap': {
        'name': 'Record Trap',
        'img': 'images/s-17.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/trap_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/trap_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/trap_320.m3u'
        }
    },
    'rock': {
        'name': 'Rock Radio',
        'img': 'images/s-18.jpg',
        'bitrates': {
            '32': 'http://air.radiorecord.ru:8102/rock_aac.m3u',
            '128': 'http://air.radiorecord.ru:8102/rock_128.m3u',
            '320': 'http://air.radiorecord.ru:8102/rock_320.m3u'
        }
    }
};

function RadioRecord() {
    ScriptableServiceScript.call(this, "Radio Record", 2, "Radio Record stations", "Radio Record stations", true);
    Amarok.debug("RadioRecord: OK");
}

function onConfigure() {
    Amarok.alert("No configuration options.");
}

function onPopulating(level, callbackData, filter) {
    Amarok.debug("RadioRecord: onPopulating");
    //For some reason Amarok appends a "%20", remove it
    //filter = filter.toLowerCase().replace(/%20$/,"").replace("%20"," ");

    //Make filter string lowercase and unescape all urlencoded "tags" ( and trim the result )
    filter = filter.toLowerCase().trim();
    filter = unescape(filter).trim();

    Amarok.debug("RadioRecord: filter = " + filter);

    if (level == 1) {
        Amarok.debug("RadioRecord: Add station stream album ...");

        for (var key in stations) {
            if (filter.length > 0) {
                var hasItems = false;
                var stationInfo = stations[key];
                if (stationInfo.name.toLowerCase().indexOf(filter) != -1) {
                    hasItems = true;
                    break;
                }

                if (!hasItems) continue;
            }

            var item = Amarok.StreamItem;
            item.level = 1;
            item.callbackData = key;
            item.itemName = stations[key].name;
            item.playableUrl = "";
            item.infoHtml = "";
            item.coverUrl = Amarok.Info.scriptPath() + "/" + stations[key].img;
            script.insertItem(item);
        }

        script.donePopulating();
    } else if (level == 0) {
        Amarok.debug("RadioRecord: Add station stream ...");

        var stationInfo = stations[callbackData];

        for (var i in stationInfo.bitrates) {
            item = Amarok.StreamItem;
            item.level = 0;
            item.callbackData = "";
            item.itemName = stationInfo.name + ' (' + i + ' kbps)';
            item.playableUrl = stationInfo.bitrates[i];
            item.album = stationInfo.name;
            item.infoHtml = '';
            item.artist = "RadioRecord";
            item.coverUrl = Amarok.Info.scriptPath() + "/" + stationInfo.img;
            item.genre = '';
            script.insertItem(item);
        }

        script.donePopulating();
    }
}

function onCustomize() {
    var currentDir = Amarok.Info.scriptPath() + "/";
    var iconPixmap = new QPixmap(currentDir + "icon.jpg");
    script.setIcon(iconPixmap);
    var emblemPixmap = new QPixmap(currentDir + "icon.jpg");
    script.setEmblem(emblemPixmap);
}

//Amarok.configured.connect( onConfigure );

script = new RadioRecord();
script.populate.connect(onPopulating);
script.customize.connect(onCustomize);